 #---------------
 # sourceview.tcl
 #---------------
 # Demonstrate gnocl::sourceView widget.
 #---------------
 # Created by William J Giddings
 # 09/12/08
 #---------------

 #!/bin/sh
 # the next line restarts using tclsh \
 exec tclsh "$0" "$@"

 package require Gnocl
 package require GnoclSourceView

 set sourceView [gnocl::sourceView \
        -showLineNumbers 1 \
        -highlightCurrentLine 1 \
        -insertSpace 0 \
        -showLineMarks 1 \
        -rightMargin 25 \
        -showRightMargin 1 \
        -tabWidth 4 \
        -baseColor #FF0000 \
        -baseFont "Mono 10" \
        -onButtonPress     {puts "buttonPress! %b"} \
        -onButtonRelease   {puts "buttonRelease %b"} \
        -onKeyPress        {puts "keyPress %k"} \
        -onKeyRelease      {puts "keyRelease %k"} \
        -onUndo            {puts "Undo %w"} \
        -onRedo            {puts "Redo %w"} ]

 gnocl::window -title "SourceView" -child $sourceView

 gnocl::mainLoop
