#---------------
# test-sourceview.tcl
#---------------
# Demonstrate gnocl::sourceView widget.
#---------------
# Created by William J Giddings
# 03/01/2010
#---------------

#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"

package require Gnocl
package require GnoclSourceView

set glade1 basicUI.glade
set glade1_widgets [gnocl::glade file $glade1]

foreach item $glade1_widgets {
    foreach {gnocl glade} $item {}
    set $glade $gnocl
    }

# rename the widgets
puts ---------------------------
puts "button1 is a [$button1 class]"
puts ---------------------------
$button1 configure -onClicked {$sv erase start end }
$button2 configure -onClicked {
        set fp [open test-sourceview.tcl "r"]
        $sv insert end [read $fp]
        close $fp}
$button3 configure -onClicked {
        foreach {sr sc er ec} [$sv search GnoclSourceView -tags SEARCH ] { puts [list $sr $sc $er $ec] }
    }
$button4 configure \
    -onClicked { $sv cut start end }
$button5 configure \
    -onClicked { $sv copy start end }
$button6 configure\
    -onClicked { $sv paste }

# add a custom sourceview, ensure that a gnocl::hBox exists in the glade file to contain it.
set sv [gnocl::sourceView \
        -showLineNumbers 1 \
        -highlightCurrentLine 1 \
        -insertSpace 0 \
        -showLineMarks 1 \
        -rightMargin 25 \
        -showRightMargin 1 \
        -tabWidth 4 \
        -baseColor #FF0000 \
        -baseFont "Mono 10" \
        -onButtonPress     {puts "buttonPress! %b"} \
        -onButtonRelease   {puts "buttonRelease %b"} \
        -onKeyPress        {puts "keyPress %k"} \
        -onKeyRelease      {puts "keyRelease %k"} \
        -onUndo            {puts "Undo %w"} \
        -onRedo            {puts "Redo %w"} ]

# create some tags
$sv tag create SEARCH -foreground red

$hbox1 add $sv -fill {1 1} -expand 1

$window1 configure -title "SourceView" -width 600 -height 800 -onDestroy {exit}
$window1 center
$window1 show


gnocl::mainLoop
